﻿using Syncfusion.UI.Xaml.Schedule;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace SelectedDateAndAppointments
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page, INotifyPropertyChanged
    {

        #region Properties

        private string selectedResourceID;

        public string SelectedResourceID
        {
            get { return selectedResourceID; }
            set 
            {
                selectedResourceID = value;
                RaisedOnPropertyChanged("SelectedResourceID");
            }
        }
        

        private DateTime selectedDate;

        public DateTime SelectedDate
        {
            get { return selectedDate; }
            set 
            {
                selectedDate = value;
                RaisedOnPropertyChanged("SelectedDate");
            }
        }
        

        private ScheduleAppointmentCollection appointments;

        public ScheduleAppointmentCollection Appointments
        {
            get { return appointments; }
            set
            {
                appointments = value;
                RaisedOnPropertyChanged("Appointments");
            }
        }

        #endregion

        #region Constructor

        public MainPage()
        {
            Appointments = new ScheduleAppointmentCollection();
            this.InitializeComponent();
            DateTime currentDate = DateTime.Now.Date;
            Random rand = new Random();
            for (int j = 0; j < 4; j++)
            {
                for (int i = 0; i < 3; i++)
                {
                    int newhour = rand.Next(1, 20);
                    Appointments.Add(new ScheduleAppointment() { StartTime = currentDate.AddDays(j).AddHours(newhour), EndTime = currentDate.AddDays(j).AddHours(newhour + 1), Subject = "Tinker Bell's Service No - " + i.ToString() + j.ToString() });
                    Appointments[i].ResourceCollection.Add(new Resource { TypeName = "ServiceAssignees", ResourceName = "123" });
                }
            }
            this.schedule1.Appointments = Appointments;

            schedule1.ScheduleTapped += schedule1_ScheduleTapped;
        }

        #endregion

        #region Methods and Events

        void schedule1_ScheduleTapped(object sender, ScheduleTappedEventArgs e)
        {
            this.date_TextBlock.Text = e.SelectedDate.ToString().Remove(11);

            SelectedResourceID = e.SelectedResource[0].ResourceName;
            this.ID_TextBlock.Text = SelectedResourceID;

            SelectedDate = (DateTime)e.SelectedDate;
        }


        private void ClearAppointments_Click_1(object sender, RoutedEventArgs e)
        {
                var apps = this.schedule1.Appointments;
                for (int i = 0; i < apps.Count; i++)
                {
                    if (apps[i].ResourceCollection.Count > 0 && apps[i].ResourceCollection[0].ResourceName == SelectedResourceID && apps[i].StartTime.Date == SelectedDate.Date)
                    {
                        Appointments.Remove(apps[i]);
                    }

                }
        }

        private void AddAppointments_Click_1(object sender, RoutedEventArgs e)
        {
            int appCount = this.schedule1.Appointments.Count;
            ScheduleAppointment app = new ScheduleAppointment() { StartTime = SelectedDate.AddHours(0), EndTime = SelectedDate.AddHours(1), Subject = SelectedResourceID + "'s Appointment" };
            app.ResourceCollection.Add(new Resource { TypeName = "ServiceAssignees", ResourceName = SelectedResourceID });
           this.schedule1.Appointments.Add(app);
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion

        
    }
}
